org.jboss.resteasy.core

## Class AcceptParameterHttpPreprocessor

- java.lang.Object
- - org.jboss.resteasy.core.AcceptParameterHttpPreprocessor

- All Implemented Interfaces:
    ContainerRequestFilter

      @PreMatching
      public class AcceptParameterHttpPreprocessor
      extends Object
      implements ContainerRequestFilter

  Enables content negotiation through a query parameter, instead of the Accept Header.

  To enable this feature, use the context-param in web.xml:

  `<context-param>
  <param-name>resteasy.media.type.param.mapping</param-name>
  <param-value>someName</param-value>
  </context-param>
  `

  So, in a request like `http://service.foo.com/resouce?someName=application/xml` the application/xml media type will received the highest priority in the content negotiation.

  In the cases where the request contains both the parameter and the Accept header, the parameter will be more relevant.

  It is possible to left the `param-value` empty, what will cause the processor to look for an accept parameter.

  Version:
    $Revision: 1.2 $
  Author:
    Leandro Ferro Luzia

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `AcceptParameterHttpPreprocessor(String paramMapping)` Create a new AcceptParameterHttpPreprocessor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `filter(ContainerRequestContext request)` Filter method called before a request has been dispatched to a resource.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### AcceptParameterHttpPreprocessor

          public AcceptParameterHttpPreprocessor(String paramMapping)

      Create a new AcceptParameterHttpPreprocessor.
      Parameters:
        `paramMapping` - The name of query parameter that will be used to do the content negotiation

  - ### Method Detail

    - #### filter

          public void filter(ContainerRequestContext request)
                      throws IOException

      Description copied from interface: `ContainerRequestFilter`
      Filter method called before a request has been dispatched to a resource.

      Filters in the filter chain are ordered according to their `javax.annotation.Priority` class-level annotation value. If a request filter produces a response by calling `ContainerRequestContext.abortWith(javax.ws.rs.core.Response)` method, the execution of the (either pre-match or post-match) request filter chain is stopped and the response is passed to the corresponding response filter chain (either pre-match or post-match). For example, a pre-match caching filter may produce a response in this way, which would effectively skip any post-match request filters as well as post-match response filters. Note however that a responses produced in this manner would still be processed by the pre-match response filter chain.

      Specified by:
        `filter` in interface `ContainerRequestFilter`
      Parameters:
        `request` - request context.
      Throws:
        `IOException` - if an I/O exception occurs.
      See Also:
        `PreMatching`

Copyright © 2014. All Rights Reserved.